//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//----
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Aqua              //eur
#property indicator_color2 Lime              //gbp
#property indicator_color3 White             //usd
#property indicator_color4 DarkOrange        //jpy
#property indicator_color5 Yellow            //aud
#property indicator_color6 Red               //nzd
#property indicator_color7 Magenta           //cad
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  1

//
//
//
//
//

extern string TimeFrame  = 15;
extern int    timeFrame = 15;
extern int    countbars=200;
extern bool AlertOn = false;
extern bool SignalOnClosedCandle = true;

int SignalCandle=0;
//
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];


string indicatorFileName;
bool   calculateValue;
bool   returnBars;
//int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexBuffer(3, ExtMapBuffer4);
   SetIndexBuffer(4, ExtMapBuffer5);
   SetIndexBuffer(5, ExtMapBuffer6);
   SetIndexBuffer(6, ExtMapBuffer7);         
   
   SetIndexStyle(0, DRAW_LINE);   SetIndexLabel(0,"EUR");
   SetIndexStyle(1, DRAW_LINE);   SetIndexLabel(1,"GBP");
   SetIndexStyle(2, DRAW_LINE);   SetIndexLabel(2,"USD");
   SetIndexStyle(3, DRAW_LINE);   SetIndexLabel(3,"JPY");
   SetIndexStyle(4, DRAW_LINE);   SetIndexLabel(4,"AUD");
   SetIndexStyle(5, DRAW_LINE);   SetIndexLabel(5,"NZD");
   SetIndexStyle(6, DRAW_LINE);   SetIndexLabel(6,"CAD");
   //
         //
         //
         //
         //
                  
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
         //
         //
         //
         //
         //
         
   IndicatorShortName(timeFrameToString(timeFrame)+" RSI MTF ");
   return(0);
}
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         //int limit;
         
   //
   //
   //
   //
   //

   i = countbars;
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,"#ConsoleRSI15X4",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      ExtMapBuffer1[i] = iCustom(NULL,timeFrame,"#ConsoleRSI15X4",0,y);
      ExtMapBuffer2[i] = iCustom(NULL,timeFrame,"#ConsoleRSI15X4",1,y);
      ExtMapBuffer3[i] = iCustom(NULL,timeFrame,"#ConsoleRSI15X4",2,y);
      ExtMapBuffer4[i] = iCustom(NULL,timeFrame,"#ConsoleRSI15X4",3,y);
      ExtMapBuffer5[i] = iCustom(NULL,timeFrame,"#ConsoleRSI15X4",4,y);
      ExtMapBuffer6[i] = iCustom(NULL,timeFrame,"#ConsoleRSI15X4",5,y);
      ExtMapBuffer7[i] = iCustom(NULL,timeFrame,"#ConsoleRSI15X4",6,y);
   }

//===================================================================================================

//=================================================================================



   return(0);
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}